// dlg.cpp : implementation file
//

#include "stdafx.h"
#include "bricks.h"
#include "dlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAskNameDlg dialog

CAskNameDlg::CAskNameDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAskNameDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAskNameDlg)
	m_name = "";
	//}}AFX_DATA_INIT
}

void CAskNameDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAskNameDlg)
	DDX_Text(pDX, IDC_EDITNAME, m_name);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAskNameDlg, CDialog)
	//{{AFX_MSG_MAP(CAskNameDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAskNameDlg message handlers





/////////////////////////////////////////////////////////////////////////////
// CHiScoresDlg dialog

CHiScoresDlg::CHiScoresDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHiScoresDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHiScoresDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CHiScoresDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHiScoresDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHiScoresDlg, CDialog)
	//{{AFX_MSG_MAP(CHiScoresDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHiScoresDlg message handlers

BOOL CHiScoresDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Set Names
	GetDlgItem(IDC_LOWNAME)->SetWindowText(m_lName);
	GetDlgItem(IDC_MEDNAME)->SetWindowText(m_mName);
	GetDlgItem(IDC_HINAME)->SetWindowText(m_hName);

	// Set Quotes
	char buffer[8];
	sprintf(buffer,"%3.1f%%",m_lQuote);
	GetDlgItem(IDC_LOWQUOTE)->SetWindowText(buffer);
	sprintf(buffer,"%3.1f%%",m_mQuote);
	GetDlgItem(IDC_MEDQUOTE)->SetWindowText(buffer);
	sprintf(buffer,"%3.1f%%",m_hQuote);
	GetDlgItem(IDC_HIQUOTE)->SetWindowText(buffer);
	
	return TRUE;
}





/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog

COptionsDlg::COptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionsDlg)
	m_clicks = FALSE;
	//}}AFX_DATA_INIT
}

void COptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDlg)
	DDX_Check(pDX, IDC_CLICKS, m_clicks);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COptionsDlg, CDialog)
	//{{AFX_MSG_MAP(COptionsDlg)
	ON_BN_CLICKED(IDC_DEFAULTS, OnClickedDefaults)
	ON_BN_CLICKED(IDC_SAVE, OnClickedSave)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_LOWSPEED, OnClickedLowspeed)
	ON_BN_CLICKED(IDC_MEDIUMSPEED, OnClickedMediumspeed)
	ON_BN_CLICKED(IDC_HIGHSPEED, OnClickedHighspeed)
	ON_BN_CLICKED(IDC_TILES, OnClickedTiles)
	ON_BN_CLICKED(IDC_BRICKS, OnClickedBricks)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg message handlers

BOOL COptionsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Prepare Scroll Bars
	((CScrollBar*)GetDlgItem(IDC_LOWSB))->SetScrollRange(MIN_SPEED,MAX_SPEED,FALSE);
	((CScrollBar*)GetDlgItem(IDC_MEDSB))->SetScrollRange(MIN_SPEED,MAX_SPEED,FALSE);
	((CScrollBar*)GetDlgItem(IDC_HIGHSB))->SetScrollRange(MIN_SPEED,MAX_SPEED,FALSE);
	((CScrollBar*)GetDlgItem(IDC_HURDLES))->SetScrollRange(MIN_HURDLES_FREQ,MAX_HURDLES_FREQ,FALSE);
	
	// Set Scroll Bars Positions
	((CScrollBar*)GetDlgItem(IDC_LOWSB))->SetScrollPos(m_lowSpeed);
	((CScrollBar*)GetDlgItem(IDC_MEDSB))->SetScrollPos(m_medSpeed);
	((CScrollBar*)GetDlgItem(IDC_HIGHSB))->SetScrollPos(m_highSpeed);
	((CScrollBar*)GetDlgItem(IDC_HURDLES))->SetScrollPos(m_hurdlesFreq);
	
	char buffer[8];
	GetDlgItem(IDC_LS_VALUE)->SetWindowText(_itoa(m_lowSpeed,buffer,10));
	GetDlgItem(IDC_MS_VALUE)->SetWindowText(_itoa(m_medSpeed,buffer,10));
	GetDlgItem(IDC_HS_VALUE)->SetWindowText(_itoa(m_highSpeed,buffer,10));
	GetDlgItem(IDC_HRDL_VALUE)->SetWindowText(_itoa(m_hurdlesFreq,buffer,10));
	
	// Set Button States
	((CButton*)GetDlgItem(IDC_LOWSPEED))->SetCheck(m_gameSpeed==m_lowSpeed);	
	((CButton*)GetDlgItem(IDC_MEDIUMSPEED))->SetCheck(m_gameSpeed==m_medSpeed);	
	((CButton*)GetDlgItem(IDC_HIGHSPEED))->SetCheck(m_gameSpeed==m_highSpeed);	

	((CButton*)GetDlgItem(IDC_TILES))->SetCheck(!m_useBricks);	
	((CButton*)GetDlgItem(IDC_BRICKS))->SetCheck(m_useBricks);	

	return TRUE; 
}

void COptionsDlg::OnClickedDefaults()
{
	m_clicks = DEF_CLICKS;
	m_useBricks = DEF_BRICKS;
	m_lowSpeed = DEF_LOW_SPEED;
	m_medSpeed = DEF_MED_SPEED;
	m_highSpeed = DEF_HIGH_SPEED;
	m_gameSpeed = DEF_MED_SPEED;
	m_hurdlesFreq = DEF_HURDLES_FREQ;
	
	UpdateData(FALSE);
	
	// Set Scroll Bars Positions
	((CScrollBar*)GetDlgItem(IDC_LOWSB))->SetScrollPos(m_lowSpeed);
	((CScrollBar*)GetDlgItem(IDC_MEDSB))->SetScrollPos(m_medSpeed);
	((CScrollBar*)GetDlgItem(IDC_HIGHSB))->SetScrollPos(m_highSpeed);
	((CScrollBar*)GetDlgItem(IDC_HURDLES))->SetScrollPos(m_hurdlesFreq);
	
	char buffer[8];
	GetDlgItem(IDC_LS_VALUE)->SetWindowText(_itoa(m_lowSpeed,buffer,10));
	GetDlgItem(IDC_MS_VALUE)->SetWindowText(_itoa(m_medSpeed,buffer,10));
	GetDlgItem(IDC_HS_VALUE)->SetWindowText(_itoa(m_highSpeed,buffer,10));
	GetDlgItem(IDC_HRDL_VALUE)->SetWindowText(_itoa(m_hurdlesFreq,buffer,10));
	
	// Set Button States
	((CButton*)GetDlgItem(IDC_LOWSPEED))->SetCheck(m_gameSpeed==m_lowSpeed);	
	((CButton*)GetDlgItem(IDC_MEDIUMSPEED))->SetCheck(m_gameSpeed==m_medSpeed);	
	((CButton*)GetDlgItem(IDC_HIGHSPEED))->SetCheck(m_gameSpeed==m_highSpeed);	

	((CButton*)GetDlgItem(IDC_TILES))->SetCheck(!m_useBricks);	
	((CButton*)GetDlgItem(IDC_BRICKS))->SetCheck(m_useBricks);	
}

void COptionsDlg::OnClickedSave()
{
	// Retrieve Data
	UpdateData();
	
	CTheApp* pApp = (CTheApp*)AfxGetApp();

	// Save INI Data
	pApp->WriteProfileInt(PARAMETERS_SECTION,CLICKS_ENTRY,m_clicks);	
	pApp->WriteProfileInt(PARAMETERS_SECTION,BRICKS_ENTRY,m_useBricks);	
	pApp->WriteProfileInt(PARAMETERS_SECTION,LOW_SPEED_ENTRY,m_lowSpeed);	
	pApp->WriteProfileInt(PARAMETERS_SECTION,MED_SPEED_ENTRY,m_medSpeed);	
	pApp->WriteProfileInt(PARAMETERS_SECTION,HIGH_SPEED_ENTRY,m_highSpeed);	
	pApp->WriteProfileInt(PARAMETERS_SECTION,GAME_SPEED_ENTRY,m_gameSpeed);	
	pApp->WriteProfileInt(PARAMETERS_SECTION,HURDLES_ENTRY,m_hurdlesFreq);	
}

void COptionsDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int* pValue = NULL;             
	int nID = pScrollBar->GetDlgCtrlID();

	if (nID==IDC_LOWSB)
		pValue = &m_lowSpeed;
		
	if (nID==IDC_MEDSB)
		pValue = &m_medSpeed;
		
	if (nID==IDC_HIGHSB)
		pValue = &m_highSpeed;
		
	if (nID==IDC_HURDLES)
		pValue = &m_hurdlesFreq;
		
	if (pValue!=NULL)
	{
		int minPos,maxPos;
		int scrollPos = pScrollBar->GetScrollPos();
		pScrollBar->GetScrollRange(&minPos,&maxPos);

		switch (nSBCode)
		{
			case SB_LEFT			:	scrollPos = minPos;
										break;
			case SB_LINELEFT		:	if (scrollPos>minPos)
											scrollPos--;
										break;	
			case SB_PAGELEFT		:	scrollPos -= 5;
										if (scrollPos<minPos)
											scrollPos = minPos;
										break;
			case SB_RIGHT			:   scrollPos = maxPos;
										break;
			case SB_LINERIGHT		:	if (scrollPos<maxPos)
											scrollPos++;
										break;	
			case SB_PAGERIGHT		:	scrollPos += 5;
										if (scrollPos>maxPos)
											scrollPos = maxPos;
										break;	
			case SB_THUMBPOSITION	:	
			case SB_THUMBTRACK		:	scrollPos = (int)nPos;
		}
	
		// Update ScrollBar Cursor Position
		*pValue = scrollPos;
		pScrollBar->SetScrollPos(scrollPos);

		// Update Float Data
		char buffer[8];
		if (nID==IDC_LOWSB)
			GetDlgItem(IDC_LS_VALUE)->SetWindowText(_itoa(scrollPos,buffer,10));
		
		if (nID==IDC_MEDSB)
			GetDlgItem(IDC_MS_VALUE)->SetWindowText(_itoa(scrollPos,buffer,10));
		
		if (nID==IDC_HIGHSB)
			GetDlgItem(IDC_HS_VALUE)->SetWindowText(_itoa(scrollPos,buffer,10));
		
		if (nID==IDC_HURDLES)                                                   
			GetDlgItem(IDC_HRDL_VALUE)->SetWindowText(_itoa(scrollPos,buffer,10));
	}
	else
		CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void COptionsDlg::OnClickedLowspeed()
{
	m_gameSpeed = m_lowSpeed;
	((CButton*)GetDlgItem(IDC_LOWSPEED))->SetCheck(m_gameSpeed==m_lowSpeed);	
	((CButton*)GetDlgItem(IDC_MEDIUMSPEED))->SetCheck(m_gameSpeed==m_medSpeed);	
	((CButton*)GetDlgItem(IDC_HIGHSPEED))->SetCheck(m_gameSpeed==m_highSpeed);	
}

void COptionsDlg::OnClickedMediumspeed()
{
	m_gameSpeed = m_medSpeed;
	((CButton*)GetDlgItem(IDC_LOWSPEED))->SetCheck(m_gameSpeed==m_lowSpeed);	
	((CButton*)GetDlgItem(IDC_MEDIUMSPEED))->SetCheck(m_gameSpeed==m_medSpeed);	
	((CButton*)GetDlgItem(IDC_HIGHSPEED))->SetCheck(m_gameSpeed==m_highSpeed);	
}

void COptionsDlg::OnClickedHighspeed()
{
	m_gameSpeed = m_highSpeed;
	((CButton*)GetDlgItem(IDC_LOWSPEED))->SetCheck(m_gameSpeed==m_lowSpeed);	
	((CButton*)GetDlgItem(IDC_MEDIUMSPEED))->SetCheck(m_gameSpeed==m_medSpeed);	
	((CButton*)GetDlgItem(IDC_HIGHSPEED))->SetCheck(m_gameSpeed==m_highSpeed);	
}

void COptionsDlg::OnClickedTiles()
{
	m_useBricks = FALSE;
	
	((CButton*)GetDlgItem(IDC_TILES))->SetCheck(TRUE);	
	((CButton*)GetDlgItem(IDC_BRICKS))->SetCheck(FALSE);	
}

void COptionsDlg::OnClickedBricks()
{
	m_useBricks = TRUE;
	
	((CButton*)GetDlgItem(IDC_TILES))->SetCheck(FALSE);	
	((CButton*)GetDlgItem(IDC_BRICKS))->SetCheck(TRUE);	
}
